const ListenerRSS = require('../listener-rss');

class AbstractListnerRSSBuilder {
    _listenerRSS = undefined;

    constructor() {
        if(this.constructor === AbstractListnerRSSBuilder)
            throw new Error('The Abstract class "AbstractListnerRSSBuilder" cannot be instantiated');
    }

    /**
     * @brief first function to call after constructor. It's building the listener
     * @param infos Must to be an object ListenerRSSInfos
     */
    constructListener(infos) {
        this._listenerRSS = new ListenerRSS();

        this.setInfos(infos);
        this.setSpecificInfos();
    }

    /**
     * @brief give the listener just build
     * @return ListenerRSS with all the setups datas
     * @exception if the listener isn't construct
     */
    get listenerRSS() {
        if(this._listenerRSS === undefined)
            throw new Error('the listener is not yet build');
        return this._listenerRSS;
    }

    setInfos(infos) { // Nominal Infos (like name, addresse, and other)
        this._listenerRSS.name = infos._name;
        this._listenerRSS.address = infos._address;
        this._listenerRSS.timeloop = infos._timeloop;
        this._listenerRSS.name = infos._name;
    }

    setSpecificInfos() { // More generic infos who's depend of platforms
        throw new Error('This function is not implemented');
    }


}

module.exports = AbstractListnerRSSBuilder